"""Basic moving living thing in-game"""

import entity, vector, projectile

import pygame

class Character(entity.Entity):
    """contains all game mechanics methods except for physics, handled by ragdoll"""
    def __init__(self, game, image):
        entity.Entity.__init__(self, game, image)
        
    def update(self):
        entity.Entity.update(self)
        
    def collidecheck(self, newpos):
        top = self.game.level.get_at(newpos.centerx, newpos.top)
        if top and top.solid == "true":
            newpos.top = top.rect.bottom
            for vec in self.vectors.values(): # if you hit top while jumping, fall
                if vec.y < 0:
                    vec.y = 0
            self.vectors["grav"] = vector.Vec2d(0, self.game.level.grav)
        bottom = self.game.level.get_at(newpos.centerx, newpos.bottom)
        if bottom and bottom.solid == "true":
            newpos.bottom = bottom.rect.top
        right1 = self.game.level.get_at(newpos.right, newpos.centery-(self.rect.height/4))
        if right1 and right1.solid == "true":
            newpos.right = right1.rect.left
        right2 = self.game.level.get_at(newpos.right, newpos.centery+(self.rect.height/4))
        if right2 and right2.solid == "true":
            newpos.right = right2.rect.left
        left1 = self.game.level.get_at(newpos.left, newpos.centery-(self.rect.height/4))
        if left1 and left1.solid == "true":
            newpos.left = left1.rect.right
        left2 = self.game.level.get_at(newpos.left, newpos.centery+(self.rect.height/4))
        if left2 and left2.solid == "true":
            newpos.left = left2.rect.right
        
        return newpos
        
    def fire(self, image, vector, despawn):
        proj = projectile.Projectile(self.game, image, vector, despawn)
        proj.rect.center = (self.rect.centerx, self.rect.bottom+int(self.rect.height*0.75))
        self.game.add(proj)
