"""Class for player character, with the special abilities and all"""

import character, vector, projectile

import pygame

import os.path

class Player(character.Character):
    """Adds in mutate and pickup features"""
    def __init__(self, game, controller):
        self.controller = controller
        character.Character.__init__(self, game, "res/chars/player/test.png")
        self.facing = "right"
        self.speed = 8
        self.jump = -32 #remember y axis flip
        self.jumping = False
        self.usetime = 20
        self.using = 0
        self.add_vector("d", (0, 0))
        self.add_vector("a", (0, 0))
        self.add_vector("space", (0, 0))
        
        
    def update(self):
        if self.controller.keys["r"]:
            self.rect.topleft = self.game.level.find_tag("spawnp")
        if self.controller.keys["d"]:
            if self.facing != "right":
                self.image = pygame.transform.flip(self.image, True, False)
                self.facing = "right"
            self.vectors["d"] = vector.Vec2d(self.speed, 0)
            
        if not self.controller.keys["d"]:
            self.vectors["d"] = vector.Vec2d(0, 0)
            
        if self.controller.keys["a"]:
            if self.facing != "left":
                self.image = pygame.transform.flip(self.image, True, False)
                self.facing = "left"
            self.vectors["a"] = vector.Vec2d(-self.speed, 0)
            
        if not self.controller.keys["a"]:
            self.vectors["a"] = vector.Vec2d(0, 0)
            
        if not self.using:
            if self.controller.mouse[1]:
                pass #mele here
                self.using = self.usetime
            elif self.controller.mouse[3]:
                self.fire("res/projectiles/arrow.png",\
                    (self.rect.center[0]-self.controller.mouse["pos"][0], \
                    self.rect.center[1]-self.controller.mouse["pos"][1]), 20)
                self.using = self.usetime
            
        below = self.game.level.get_at(self.rect.centerx, self.rect.inflate(2, 2).bottom)
        if below and below.solid == "true":
            self.vectors["space"] = vector.Vec2d(0, 0)
            if self.controller.keys["space"]:
                self.vectors["space"] = vector.Vec2d(0, self.jump)
        if self.using:
            self.using -= 1
        character.Character.update(self)
